Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.beans.factory
Interface FactoryBean

All Known Subinterfaces:
  SmartFactoryBean

All Known Implementing Classes:
  AbstractEntityManagerFactoryBean, AbstractFactoryBean, AbstractServiceLoaderBasedFactoryBean, AbstractSessionFactoryBean, AbstractSingletonProxyFactoryBean, AnnotationSessionFactoryBean, BeanReferenceFactoryBean, BurlapProxyFactoryBean, CommonsLogFactoryBean, ConnectorServerFactoryBean, EhCacheFactoryBean, EhCacheManagerFactoryBean, FieldRetrievingFactoryBean, FilterDefinitionFactoryBean, FreeMarkerConfigurationFactoryBean, HessianProxyFactoryBean, HttpInvokerProxyFactoryBean, JaxRpcPortProxyFactoryBean, JaxWsPortProxyFactoryBean, JmsInvokerProxyFactoryBean, JndiObjectFactoryBean, JndiRmiProxyFactoryBean, JotmFactoryBean, ListFactoryBean, LocalConnectionFactoryBean, LocalContainerEntityManagerFactoryBean, LocalEntityManagerFactoryBean, LocalJaxRpcServiceFactoryBean, LocalJaxWsServiceFactoryBean, LocalPersistenceManagerFactoryBean, LocalSessionFactoryBean, LocalSessionFactoryBean, LocalStatelessSessionProxyFactoryBean, MapFactoryBean, MBeanProxyFactoryBean, MBeanServerConnectionFactoryBean, MBeanServerFactoryBean, MethodInvokingFactoryBean, MethodInvokingJobDetailFactoryBean, MethodInvokingTimerTaskFactoryBean, MethodLocatingFactoryBean, ObjectFactoryCreatingFactoryBean, PropertiesFactoryBean, PropertyPathFactoryBean, ProxyFactoryBean, ResourceAdapterFactoryBean, ResourceMapFactoryBean, RmiProxyFactoryBean, RmiRegistryFactoryBean, ScheduledExecutorFactoryBean, ScheduledExecutorFactoryBean, SchedulerFactoryBean, ScopedProxyFactoryBean, ServiceFactoryBean, ServiceListFactoryBean, ServiceLoaderFactoryBean, ServiceLocatorFactoryBean, ServletContextAttributeFactoryBean, ServletContextFactoryBean, ServletContextParameterFactoryBean, SetFactoryBean, SharedEntityManagerBean, SimpleHttpServerFactoryBean, SimpleRemoteStatelessSessionProxyFactoryBean, SqlMapClientFactoryBean, TimerFactoryBean, TimerManagerFactoryBean, TransactionAwarePersistenceManagerFactoryProxy, TransactionAwareSessionAdapter, TransactionProxyFactoryBean, VelocityEngineFactoryBean, WebLogicJndiMBeanServerFactoryBean, WebLogicMBeanServerFactoryBean, WebSphereMBeanServerFactoryBean, WebSphereTransactionManagerFactoryBean

    public interface FactoryBean

Interface to be implemented by objects used within a `BeanFactory` which are themselves factories. If a bean implements this interface, it is used as a factory for an object to expose, not directly as a bean instance that will be exposed itself.

NB: A bean that implements this interface cannot be used as a normal bean. A FactoryBean is defined in a bean style, but the object exposed for bean references (`getObject()` is always the object that it creates.

FactoryBeans can support singletons and prototypes, and can either create objects lazily on demand or eagerly on startup. The `SmartFactoryBean` interface allows for exposing more fine-grained behavioral metadata.

This interface is heavily used within the framework itself, for example for the AOP `ProxyFactoryBean` or the `JndiObjectFactoryBean`. It can be used for application components as well; however, this is not common outside of infrastructure code.

NOTE: FactoryBean objects participate in the containing BeanFactory's synchronization of bean creation. There is usually no need for internal synchronization other than for purposes of lazy initialization within the FactoryBean itself (or the like).

Since:
  08.03.2003
Author:
  Rod Johnson, Juergen Hoeller
See Also:
  `BeanFactory`, `ProxyFactoryBean`, `JndiObjectFactoryBean`

Method Summary
`Object` | `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
`Class` | `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
`boolean` | `isSingleton()` Is the object managed by this factory a singleton?

Method Detail

### getObject

    Object getObject()
                     throws Exception

  Return an instance (possibly shared or independent) of the object managed by this factory.

  As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

  If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

  As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

  Returns:
    an instance of the bean (can be `null`)
  Throws:
    `Exception` - in case of creation errors
  See Also:
    `FactoryBeanNotInitializedException`

### getObjectType

    Class getObjectType()

  Return the type of object that this FactoryBean creates, or `null` if not known in advance.

  This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

  In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

  This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

  NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

  Returns:
    the type of object that this FactoryBean creates, or `null` if not known at the time of the call
  See Also:
    `ListableBeanFactory.getBeansOfType(java.lang.Class)`

### isSingleton

    boolean isSingleton()

  Is the object managed by this factory a singleton? That is, will `getObject()` always return the same object (a reference that can be cached)?

  NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

  The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

  NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

  Returns:
    whether the exposed object is a singleton
  See Also:
    `getObject()`, `SmartFactoryBean.isPrototype()`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002-2008 The Spring Framework.